<script setup lang="ts">
import { ref, computed } from 'vue'
import type { VForm } from 'vuetify/components'
import { useSalaryStore } from '../stores/salary'

const salaryStore = useSalaryStore()

const selectedId = computed(() => salaryStore.selectedId)
const form = ref(false)
const dialog = computed(() => salaryStore.dialog)

const pendingEmployee = ref(salaryStore.pendingSlips.map((item) => item.employeeID))

function onSubmit() {}

function Close() {
  salaryStore.closeDialog()
}

function Save() {
  if (selectedId.value > 0) {
    salaryStore.savePaidSlip()
  }
  Close()
}
function updateFormValue() {
  if (selectedId.value > 0) {
    console.log(selectedId.value)
    salaryStore.editedSlip = Object.assign(
      {},
      salaryStore.pendingSlips.find((item) => item.employeeID === selectedId.value)
    )

    // salaryStore.editedSlip.employeeId = selectedId.value
    // salaryStore.editedSlip.period = getMonthRange(new Date())
    // salaryStore.editedSlip.date = new Date().toISOString().substr(0, 10)
    // salaryStore.editedSlip.name = employeeStore.employees.find((employee) => employee.id === selectedId.value)?.firstName + " " + employeeStore.employees.find((employee) => employee.id === selectedId.value)?.lastName
    // salaryStore.editedSlip.role = employeeStore.employees.find((employee) => employee.id === selectedId.value)?.roles
  }
}

function getMonthRange(date: Date) {
  const year = date.getFullYear()
  const month = date.getMonth()
  const firstDay = new Date(year, month, 1)
  const lastDay = new Date(year, month + 1, 0)

  const formattedFirstDay = formatDate(firstDay)
  const formattedLastDay = formatDate(lastDay)

  return `${formattedFirstDay} - ${formattedLastDay}`
}

function formatDate(date: Date) {
  const day = String(date.getDate()).padStart(2, '0')
  const month = String(date.getMonth() + 1).padStart(2, '0')
  const year = String(date.getFullYear())

  return `${day}/${month}/${year}`
}

// Usage example:
const date = new Date()
const range = getMonthRange(date)
console.log(range) // Output: "01/01/2023 - 31/01/2023"
console.log(date)
</script>
<template>
  <v-dialog v-model="dialog" max-width="1024px" persistent>
    <template v-slot:activator="{ props }">
      <v-btn dark class="mb-2" v-bind="props" @click="salaryStore.NewRecord()">
        <v-icon icon="mdi-note-plus" style="padding-right: 10px"></v-icon>
        <p0 class="font-weight-bold">Create</p0>
      </v-btn>
    </template>
    <v-card rounded="lg">
      <v-card-title>
        <div class="text-center">
          <span class="text-h5">สลิปเงินเดือน / Salary Slip</span>
        </div>
      </v-card-title>
      <v-card-text>
        <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
          <v-container>
            <v-row>
              <v-col cols="12" md="7">
                <v-row>
                  <v-col cols="12" md="3">
                    รหัสพนักงาน:
                    <v-combobox
                      label="ID"
                      :items="pendingEmployee"
                      required
                      v-model="salaryStore.selectedId"
                      @update:model-value="updateFormValue()"
                    >
                    </v-combobox>
                  </v-col>
                  <v-col cols="12" md="9">
                    ชื่อนามสกุล: <br />
                    <h3>{{ salaryStore.editedSlip.name }}</h3>
                  </v-col>
                </v-row>
                <v-row>
                  <v-col cols="12" md="3">
                    ตำแหน่ง: <br />
                    <h3>{{ salaryStore.editedSlip.roles }}</h3>
                  </v-col>
                </v-row>
              </v-col>
              <v-col cols="12" md="5">
                <v-row>
                  <v-col cols="4" class="text-left">
                    รอบเงินเดือน: <br />
                    Payroll Period
                  </v-col>
                  <v-col cols="8" class="text-left">
                    {{ salaryStore.editedSlip.period }}
                  </v-col>
                </v-row>
                <v-row>
                  <v-col cols="4" class="text-left">
                    วันที่ชำระ: <br />
                    Payment Date
                  </v-col>
                  <v-col cols="8" class="text-left">
                    {{ salaryStore.editedSlip.date }}
                  </v-col>
                </v-row>
                <v-row>
                  <v-col cols="4" class="text-left">
                    เลขที่บัญชี: <br />
                    Bank Account
                  </v-col>
                </v-row>
              </v-col>
            </v-row>
            <v-row>
              <v-col cols="12">
                <v-sheet>
                  <v-table class="border">
                    <thead>
                      <tr>
                        <th style="text-align: center">
                          <h2>เงินได้</h2>
                          <p>Earnings</p>
                        </th>
                        <th style="text-align: center">
                          <h2>รายการหัก</h2>
                          <p>Deductions</p>
                        </th>
                        <th style="text-align: center">
                          <h2>ปี</h2>
                          <p>{{ salaryStore.editedSlip.period.substring(6, 10) }}</p>
                        </th>
                      </tr>
                    </thead>
                    <tbody>
                      <tr>
                        <td>
                          <v-row>
                            <v-col cols="12" md="7">
                              <h3>เงินเดือน/ค่าจ้าง</h3>
                              <p>Salary/Wage</p>
                            </v-col>
                            <v-col cols="12" md="5" class="text-right">
                              <v-text-field
                                v-model="salaryStore.editedSlip.defaultSalary"
                                variant="underlined"
                                :value="salaryStore.editedSlip.defaultSalary"
                              ></v-text-field>
                            </v-col>
                          </v-row>
                          <v-row>
                            <v-col cols="12" md="7">
                              <h3>ค่าล่วงเวลา</h3>
                              <p>Overtime</p>
                            </v-col>
                            <v-col cols="12" md="5" class="text-right">
                              <p1>0.00</p1>
                            </v-col>
                          </v-row>
                          <v-row>
                            <v-col cols="12" md="7">
                              <h3>ค่านายหน้า</h3>
                              <p>Commission</p>
                            </v-col>
                            <v-col cols="12" md="5" class="text-right">
                              <p1>0.00</p1>
                            </v-col>
                          </v-row>
                          <v-row>
                            <v-col cols="12" md="7">
                              <h3>ค่าเบี้ยเลี้ยง</h3>
                              <p>Allowances</p>
                            </v-col>
                            <v-col cols="12" md="5" class="text-right">
                              <p1>0.00</p1>
                            </v-col>
                          </v-row>
                          <v-row>
                            <v-col cols="12" md="7">
                              <h3>โบนัส</h3>
                              <p>Bonus</p>
                            </v-col>
                            <v-col cols="12" md="5" class="text-right">
                              <p1>0.00</p1>
                            </v-col>
                          </v-row>
                          <v-row>
                            <v-col cols="12" md="7">
                              <h3>เงินได้อื่น ๆ</h3>
                              <p>Others</p>
                            </v-col>
                            <v-col cols="12" md="5" class="text-right">
                              <p1>0.00</p1>
                            </v-col>
                          </v-row>
                        </td>
                        <td>
                          <v-row>
                            <v-col cols="12" md="7">
                              <h3>ประกันสังคม</h3>
                              <p>Social Security Fund</p>
                            </v-col>
                            <v-col cols="12" md="5" class="text-right">
                              <p1>0.00</p1>
                            </v-col>
                          </v-row>
                          <v-row>
                            <v-col cols="12" md="7">
                              <h3>ภาษีหัก ณ ที่จ่าย</h3>
                              <p>Withholding Tax</p>
                            </v-col>
                            <v-col cols="12" md="5" class="text-right">
                              <p1>0.00</p1>
                            </v-col>
                          </v-row>
                          <v-row>
                            <v-col cols="12" md="7">
                              <h3>เงินกู้ยืม กยศ./กรอ.</h3>
                              <p>Student Loan Fund</p>
                            </v-col>
                            <v-col cols="12" md="5" class="text-right">
                              <p1>0.00</p1>
                            </v-col>
                          </v-row>
                          <v-row>
                            <v-col cols="12" md="7">
                              <h3>เงินประกัน</h3>
                              <p>Deposit</p>
                            </v-col>
                            <v-col cols="12" md="5" class="text-right">
                              <p1>0.00</p1>
                            </v-col>
                          </v-row>
                          <v-row>
                            <v-col cols="12" md="7">
                              <h3>ขาด/ลา/มาสาย</h3>
                              <p>Absent/Leave/Late</p>
                            </v-col>
                            <v-col cols="12" md="5" class="text-right">
                              <p1>{{ salaryStore.editedSlip.lossSalary?.toFixed(2) }}</p1>
                            </v-col>
                          </v-row>
                          <v-row>
                            <v-col cols="12" md="7">
                              <h3>รายการหักอื่นๆ</h3>
                              <p>Others</p>
                            </v-col>
                            <v-col cols="12" md="5" class="text-right">
                              <p1>0.00</p1>
                            </v-col>
                          </v-row>
                        </td>
                        <td>
                          <v-col cols="12">
                            <v-row>
                              <v-col cols="12" md="7">
                                <h3>เงินได้สะสม</h3>
                                <p>YTD Earnings</p>
                              </v-col>
                              <v-col cols="12" md="5" class="text-right">
                                <p1>0.00</p1>
                              </v-col>
                            </v-row>
                            <v-row>
                              <v-col cols="12" md="7">
                                <h3>ภาษีหัก ณ ที่จ่ายสะสม</h3>
                                <p>YTD Withholding Tax</p>
                              </v-col>
                              <v-col cols="12" md="5" class="text-right">
                                <p1>0.00</p1>
                              </v-col>
                            </v-row>
                            <v-row>
                              <v-col cols="12" md="7">
                                <h3>เงินประกันสังคมสะสม</h3>
                                <p>Accumulated SSF</p>
                              </v-col>
                              <v-col cols="12" md="5" class="text-right">
                                <p1>0.00</p1>
                              </v-col>
                            </v-row>
                          </v-col>

                          <v-col cols="12" class="border">
                            <v-row>
                              <v-col cols="12" md="7">
                                <h3>รวมเงินได้</h3>
                                <p>Deposit</p>
                              </v-col>
                              <v-col cols="12" md="5" class="text-right">
                                <p1>{{ salaryStore.editedSlip.defaultSalary?.toFixed(2) }}</p1>
                              </v-col>
                            </v-row>
                            <v-row>
                              <v-col cols="12" md="7">
                                <h3>รวมรายการหัก</h3>
                                <p>Total Deductions</p>
                              </v-col>
                              <v-col cols="12" md="5" class="text-right">
                                <p1>{{ salaryStore.editedSlip.lossSalary?.toFixed(2) }}</p1>
                              </v-col>
                            </v-row>
                            <v-row>
                              <v-col cols="12" md="7">
                                <h3>เงินได้สุทธิ</h3>
                                <p>Net Earnings</p>
                              </v-col>
                              <v-col cols="12" md="5" class="text-right">
                                <p1>{{ salaryStore.editedSlip.netSalary?.toFixed(2) }}</p1>
                              </v-col>
                            </v-row>
                          </v-col>
                        </td>
                      </tr>
                    </tbody>
                  </v-table>
                </v-sheet>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
        <small>*indicates required field</small>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="blue-darken-1" variant="text" @click="Close()"> Close </v-btn>
        <v-btn color="blue-darken-1" variant="text" @click="Save()"> Save </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
<style scoped>
p {
  font-size: 12px;
}

p0 {
  font-size: 16px;
}

p1 {
  font-size: 20px;
}
</style>
